function [msvm,BOOLsuccess]=COMlinSVMmulti(X,C,y)
  tic;
  BiasConst=100;
  X(end+1,:)=BiasConst; % Simulate a bias with a const feature
  [problem,probdata]=setupMSVM(X,C,y,BiasConst);
  [x,fval,exitflag,out,lambda]=quadprog(problem);
  if (exitflag>0),
    BOOLsuccess=true;
    msvm=getmsvmparms(X,C,y,x,fval,toc,out,probdata);
  else, msvm=[]; BOOLsuccess=false; out, out.message, keyboard; end;
end

function [problem,probdata]=setupMSVM(X,C,y,BiasConst)
  ClassIDs=unique(y);
  probdata.BiasConst=BiasConst;
  probdata.NUMclasses=length(ClassIDs);
  [probdata.NUMdims,probdata.NUMpts]=size(X);
  NUMw=probdata.NUMdims*probdata.NUMclasses;
  NUMvars=NUMw+probdata.NUMpts;
  NUMconst=(probdata.NUMclasses-1)*probdata.NUMpts;
  probdata.INDw=reshape([1:NUMw],probdata.NUMdims,probdata.NUMclasses);
  probdata.INDxi=NUMw+[1:probdata.NUMpts]';
  
  problem.H=zeros(NUMvars,NUMvars);
  problem.H(probdata.INDw,probdata.INDw)=eye(NUMw);
  problem.f=zeros(NUMvars,1);
  problem.f(probdata.INDxi)=C;
  problem.Aineq=zeros(NUMconst,NUMvars);
  k=0;
  for i=[1:probdata.NUMpts],
    yind=find(y(i)==ClassIDs);
    for l=setdiff([1:probdata.NUMclasses],yind),
      k=k+1;
      problem.Aineq(k,probdata.INDxi(i))=-1;
      problem.Aineq(k,probdata.INDw(:,yind))=-X(:,i)';
      problem.Aineq(k,probdata.INDw(:,l))=X(:,i)';
    end;
  end;
  problem.bineq=-ones(NUMconst,1);
  problem.Aeq=[];
  problem.beq=[];
  problem.x0=zeros(NUMvars,1);
  problem.lb=-Inf(NUMvars,1);
  problem.lb(probdata.INDxi)=0;
  problem.ub=+Inf(NUMvars,1);
  problem.solver='quadprog';
  problem.options=optimset('Display','off','LargeScale','off','MaxIter',2000);
end

function msvm=getmsvmparms(X,C,y,x,primalobj,traintime,out,probdata)
  tmp=x(probdata.INDw);

  msvm=[];
  msvm.time=traintime;
  msvm.b=tmp(end,:)'*probdata.BiasConst;
  msvm.w=tmp(1:end-1,:);
  msvm.xi=x(probdata.INDxi);
  msvm.trainerr=100*mean(msvm.xi>1);
  msvm.ClassIDs=unique(y);
  msvm.primalobj=primalobj;
  msvm.diagnostic.NUMiter=out.iterations;
  msvm.diagnostic.MSGexit=out.message;
end
