function [model,predict]=COMnaivebayes(FEAtrn,LBLtrn,FEAtst,LBLtst)
  ClassIDs=unique(LBLtrn);
  NUMclasses=length(ClassIDs);
  [NUMdims,NUMpts]=size(FEAtrn);

  sigma=zeros(NUMdims,1);
  for i=1:NUMclasses,
    ind=find(LBLtrn==ClassIDs(i));
    X=FEAtrn(:,ind);
    NUMclasspts=length(ind);
    
    model(i).mu=mean(X,2);
    model(i).ClassID=ClassIDs(i);
    model(i).py=NUMclasspts/NUMpts;
    tmp=X-repmat(model(i).mu,1,NUMclasspts);
    sigma=sigma+sum(tmp.*tmp,2);
  end;
  sigma=sqrt(sigma./NUMpts);
  for i=1:NUMclasses, model(i).sigma=sigma; end;

  if (~isempty(FEAtst)),
    NUMtst=size(FEAtst,2);
    P=zeros(NUMtst,NUMclasses);
    for i=1:NUMclasses,
      P(:,i)=mvnpdf(FEAtst',model(i).mu',diag(model(i).sigma));
      P(:,i)=P(:,i)*model(i).py;
    end;
    P=P./repmat(sum(P,2),1,NUMclasses);
    [maxval,maxind]=max(P');
    predict.probs=P';
    predict.labels=ClassIDs(maxind);
    if (~isempty(LBLtst)),
      predict.accuracy=100*mean(predict.labels==LBLtst);
    end;
  end;
end